// SVG namespace
var svgNS = "http://www.w3.org/2000/svg";

// the SVG document handler
var documentSVG = null;

// payload global
var payload = null;

// the components
var components = null;
var zoomer = null; 

// how often to request new data from server? (steve: 250)
var updateInterval = 100; 
 
//to send back to Q if need be
var parms = "?state=init";

//time between clicks to be a double click
var doubleClickTime = 250;

var mouseX = -1;
var mouseY = -1;
var key = '';
var mouseDownElement = null;

function mousemove(evt) {		
	var anX = evt.clientX;
	var aY = evt.clientY;
	mouseX = anX;
	mouseY = aY;
	pollQ();
}

function keypressed(evt) {		
	var aCode = evt.getCharCode();
        key = String.fromCharCode(aCode);
	alert(key);
}

function clearParms() {
	mouseX = -1;
	mouseY = -1;
	key = '';
 	parms = "";
}

function getParms() {
	if (mouseX == -1 && mouseY == -1) return parms;
	if (parms != "") parms = parms + "&";
	parms = parms + "x=" + mouseX + "&y=" + mouseY;
	return parms;
}

function init(evt) {
	documentSVG = evt.target.ownerDocument; 
	components = documentSVG.createElementNS(svgNS, "g");
	documentSVG.documentElement.appendChild(components);
	setInterval("pollQ()", updateInterval);
}

function pollQ() {
	if (window.getURL) getURL("svg_chart_q?" + getParms(), handleResults);
	else ajaxRequest("svg_chart_q?" + getParms(), handleResults);
	clearParms();
}

function handleResults(data) {
	if (window.getURL) responseText = data.content;
	else responseText = data; 

	var theResponses = responseText.split("\r");

	for (var i = 0; i < theResponses.length; i++)	
	{ 
		var theStrings = theResponses[i].split("\t");		
		theMap = new Map();
		var j = 0;
		while (j < theStrings.length)
			{
 				var aKey = theStrings[j];
				var aValue = theStrings[j+1];
				if (aKey != "")	theMap.put(aKey,aValue);
				j = j + 2;	
			}
		processPayload(theMap);
	}

}
function processPayload(aMap) {
	if (aMap.isEmpty()) return;
	//aMap.view();
	var aCommand = aMap.get("f");
	aMap.removeKey("f");
	payload = aMap;
	window.eval(aCommand + "()");
	payload = null;
}
function da() {
	documentSVG.documentElement.removeChild(components);
	components = documentSVG.createElementNS(svgNS, "g");
	documentSVG.documentElement.appendChild(components);
}
function bs() {
	var aMap = payload;
	var aShapeName = aMap.get("shape");
	var aShape = documentSVG.createElementNS(svgNS, aShapeName);
	aShape.setAttribute("title",aShapeName);
	aMap.removeKey(aShapeName);
	update(aShape, aMap);	
  	components.appendChild(aShape);
}

function us() {
	var aShape = document.getElementById(payload.get("id")); 
	payload.removeKey("id");
	update(aShape, payload);	
}

function sv() {
	if (parms != "") parms = parms + "&";
	parms = parms + payload.get("vars");
}

function oc() {		//ok cancel
	var aQuestion = payload.get("text");
	var aOC = window.confirm(aQuestion);
	if (parms != "") parms = parms + "&";
	parms = parms + "response=" + aOC;
}

function au() {		//alert user
	var aQuestion = payload.get("text");
	window.alert(aQuestion);
}

function pu() {		//prompt user
	var aQuestion = payload.get("text");
	var aReponse = window.prompt(aQuestion);
	if (parms != "") parms = parms + "&";
	parms = parms + "response=" + aReponse;
}

function ds() {		//delete shapes
	var theIds = payload.get("id").split(",");
	for (var i = 0; i < theIds.length; i++)	
		{ 
 			var anId = theIds[i];
			var aShape = document.getElementById(anId); 
			var aParent = aShape.parentNode;
			aParent.removeChild(aShape);
		}
}

function zoom() {
	var aRadius = parseInt(zoomer.getAttribute("r"));
	if (aRadius < 1000)
		{
			zoomer.setAttribute("r","" + (40 + aRadius));
			setTimeout(zoom,5);
			return;
		}
	components.removeChild(zoomer); 
}
  	
function am() {
	//re-add the node to make it on top
	var aNode = document.getElementById(payload.get("id"));
	zoomer = aNode.cloneNode(true); 
	zoomer.setAttribute("fill-opacity", "100");
	components.appendChild(zoomer); 
	setTimeout(zoom,5);
}

function update(aShape, aMap) {
	var anIterator = aMap.iterator();
	if (aShape.nodeName == "text" && aMap.containsKey("content"))
		{
			var aContent = aMap.get("content");
			if (aShape.hasChildNodes()) aShape.removeChild(aShape.firstChild);
			aShape.appendChild(document.createTextNode(aContent));
			aMap.removeKey("content");
		}
	while (anIterator.hasNext())
		{
			var aKey = anIterator.next();
			var aValue = aMap.get(aKey);
			aShape.setAttribute(aKey, aValue); // X position
		}
}

lmc = new Date().valueOf();

function click(anSVGElement) {
	var timeNow = new Date().valueOf();
	var lastClick = lmc;
	lmc = timeNow;
	if ((timeNow - lastClick) < doubleClickTime) return doubleClick(anSVGElement);
	var anId = anSVGElement.id; 	
	if (parms != "") parms = parms + "&";
	parms = parms + "click=" + anId;
}

function doubleClick(anSVGElement) {
	var anId = anSVGElement.id; 	
	if (parms != "") parms = parms + "&";
	parms = parms + "doubleclick=" + anId;
}

function mouseup(evt) {
	if (mouseDownElement == null) return;
	var anId = mouseDownElement.id; 	
	if (parms != "") parms = parms + "&";
	parms = parms + "mouseup=" + anId;
	mouseDownElement = null;
}

function mousedown(anSVGElement) {
	mouseDownElement = anSVGElement;
	var anId = anSVGElement.id; 	
	if (parms != "") parms = parms + "&";
	parms = parms + "mousedown=" + anId;
}

function mouseover(anSVGElement) {
	var anId = anSVGElement.id; 		
	if (parms != "") parms = parms + "&";
	parms = parms + "mouseover=" + anId;
}

function mouseout(anSVGElement) {
	var anId = anSVGElement.id; 	
	if (parms != "") parms = parms + "&";
	parms = parms + "mouseout=" + anId;
}

function setstatus(aString) {
	window.status = aString;
}
